--[[
LuckyCharms2 r40
Last Changed By: neer
Last Changed: 2012-10-01T18:23:27Z
]]

--LuckyCharms.Message(IsAddOnLoaded("Masque"))--DEBUG
if not IsAddOnLoaded("Masque") then return end
 
local LC2_Realm = GetCVar("realmName"); --Get Realm for Profile.
local LC2_Char = UnitName("player"); --Get char name for profile.
local LC2Profile = LC2_Realm.." - "..LC2_Char;
local BFLC2 = CreateFrame("Frame")
local self = BFLC2
BFLC2:SetScript("OnEvent", function(this, event, ...)
	this[event](this, ...)
end)

local LBF = LibStub("Masque")
local db = {}


BFLC2:RegisterEvent("PLAYER_ENTERING_WORLD")
function BFLC2:PLAYER_ENTERING_WORLD()

	self:UnregisterEvent("PLAYER_ENTERING_WORLD")

	LC2_Settings[LC2Profile].BtnFacade = LC2_Settings[LC2Profile].BtnFacade or {}
	db = LC2_Settings[LC2Profile].BtnFacade
	--db.dbinit = 0;--Quick Reset Debug

	if db.dbinit ~= 1 then
		local defaults = {
			groups = {
				["Charm Buttons"] = {
					skin = "Blizzard",
					gloss = false,
					backdrop = false,
					colors = {},
				},
				["Lock Button"] = {
					skin = "Blizzard",
					gloss = false,
					backdrop = false,
					colors = {},
				},
				["Crowd Control Buttons"] = {
					skin = "Blizzard",
					gloss = false,
					backdrop = false,
					colors = {},
				},
				["World Marker Buttons"] = {
					skin = "Blizzard",
					gloss = false,
					backdrop = false,
					colors = {},
				},
			},
			dbinit = 1,
		}
		db = defaults
		LC2_Settings[LC2Profile].BtnFacade = db
	end
	self.db = db

	
	local lbfgroup = LBF:Group(LC2Name, "Charm Buttons")
	lbfgroup:Skin(self.db.groups["Charm Buttons"].skin, self.db.groups["Charm Buttons"].gloss, self.db.groups["Charm Buttons"].backdrop, self.db.groups["Charm Buttons"].colors)
	
	lbfgroup = LBF:Group(LC2Name, "Lock Button")
	lbfgroup:Skin(self.db.groups["Lock Button"].skin, self.db.groups["Lock Button"].gloss, self.db.groups["Lock Button"].backdrop, self.db.groups["Lock Button"].colors)
	
	lbfgroup = LBF:Group(LC2Name, "Crowd Control Buttons")
	lbfgroup:Skin(self.db.groups["Crowd Control Buttons"].skin, self.db.groups["Crowd Control Buttons"].gloss, self.db.groups["Crowd Control Buttons"].backdrop, self.db.groups["Crowd Control Buttons"].colors)
	
	lbfgroup = LBF:Group(LC2Name, "World Marker Buttons")
	lbfgroup:Skin(self.db.groups["World Marker Buttons"].skin, self.db.groups["World Marker Buttons"].gloss, self.db.groups["World Marker Buttons"].backdrop, self.db.groups["World Marker Buttons"].colors)
 
 
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm1"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm2"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm3"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm4"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm5"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm6"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm7"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm8"]);
	LBF:Group(LC2Name, "Charm Buttons"):AddButton(_G["LuckyCharm0"]);
	
	LBF:Group(LC2Name, "Lock Button"):AddButton(_G["LCBDragButton"]);
	
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C1"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C2"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C3"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C4"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C5"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C6"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C7"]);
	LBF:Group(LC2Name, "Crowd Control Buttons"):AddButton(_G["LCKillOrder_C8"]);
	
	
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare1"]);
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare2"]);
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare3"]);
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare4"]);
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare5"]);
	LBF:Group(LC2Name, "World Marker Buttons"):AddButton(_G["LuckyCharm2Flare6"]);

	LBF:Register(LC2Name, BFLC2.SkinCallback, self);
	 
	--LBF:RegisterSkinCallback(LC2Name, function(_, SkinID, Gloss, Backdrop, Group, Button, Colors)
		--LuckyCharms.Message(Group)--DEBUG
		--if not Group then return end
		--self.db.groups[Group].skin = SkinID
		--self.db.groups[Group].gloss = Gloss
		--self.db.groups[Group].backdrop = Backdrop
		--self.db.groups[Group].colors = Colors
		--if(Group == "Charm Buttons") then LuckyCharms.SetTexCoords() end
		--if(Group == "World Marker Buttons") then LuckyCharms.Flares.SetTexCoords() end
	--end, self)
	LuckyCharms.SetTexCoords();
	LuckyCharms.Flares.SetTexCoords();
end

--Callback(arg, Group, SkinID, Gloss, Backdrop, Colors, Fonts)
function BFLC2.SkinCallback(arg, group, skin, gloss, backdrop, colors, fonts)
    --LuckyCharms.Message(group)--DEBUG
		
		if not group then return end
		
		self.db.groups[group].skin = skin;
		self.db.groups[group].gloss = gloss;
		self.db.groups[group].backdrop = backdrop;
		self.db.groups[group].colors = colors;
		
		if(group == "Charm Buttons") then 
			LuckyCharms.SetTexCoords()
		end
		
		if(group == "World Marker Buttons") then 
			LuckyCharms.Flares.SetTexCoords()
		end
    
    --LuckyCharms_msg("ButtonFacade SKin Callback!");--Debug
    --LuckyCharms_msg(arg);--Debug
    --LuckyCharms_msg(group);--Debug
    --LuckyCharms_msg(skin);--Debug
end